// #autoload
// #name = _ZTabMenu
// #category = ZephyrFox's Scripts
// #description = A tab-menu HUD script.
// #version = 0.5
// #date = 02.05.2004
// #status = testing
// #author = Anthony Vrabel
// #warrior = ZephyrFox
// #email = ZephyrFox@hotmail.com
// #web = www.zephyrfox.com
// #credits = Qing, this is based heavily on his QAdminMenu
// #readme = _ZTabMenuHUD.txt
// #include = support/callback.cs
// #include = support/mission_callbacks.cs
// #include = support/team_tracker.cs

package ZTabMenuHUDoverloads
{
	function OptionsDlg::onWake(%this)
	{
		if (!$ZTabMenuHUDBind)
		{
			$RemapName[$RemapCount] = "ZTabMenuHUD";
			$RemapCmd[$RemapCount]  = "ZTabMenuHUDToggle";
			$RemapCount++;
			$ZTabMenuHUDBind = true;
		}
	
		parent::onWake(%this);
	}

	function PlayGui::onWake(%this)
	{
		if(!$pref::ZTabMenuHUDteam1::Column0)
		{
			$pref::ZTabMenuHUDteam1::Column0 = 24;
			$pref::ZTabMenuHUDteam1::Column1 = 200;
			$pref::ZTabMenuHUDteam1::Column2 = 50;
			$pref::ZTabMenuHUDteam1::Column3 = 50;
			$pref::ZTabMenuHUDteam1::Column4 = 50;
			$pref::ZTabMenuHUDteam1::Column5 = 75;
			$pref::ZTabMenuHUDteam1::SortColumnKey = 3;
			$pref::ZTabMenuHUDteam1::SortInc = 0;

			$pref::ZTabMenuHUDteam2::Column0 = 24;
			$pref::ZTabMenuHUDteam2::Column1 = 200;
			$pref::ZTabMenuHUDteam2::Column2 = 50;
			$pref::ZTabMenuHUDteam2::Column3 = 50;
			$pref::ZTabMenuHUDteam2::Column4 = 50;
			$pref::ZTabMenuHUDteam2::Column5 = 75;
			$pref::ZTabMenuHUDteam2::SortColumnKey = 3;
			$pref::ZTabMenuHUDteam2::SortInc = 0;

			$pref::ZTabMenuHUDobs::Column0 = 24;
			$pref::ZTabMenuHUDobs::Column1 = 200;
			$pref::ZTabMenuHUDobs::Column2 = 50;
			$pref::ZTabMenuHUDobs::Column3 = 50;
			$pref::ZTabMenuHUDobs::Column4 = 50;
			$pref::ZTabMenuHUDobs::Column5 = 75;
			$pref::ZTabMenuHUDobs::SortColumnKey = 3;
			$pref::ZTabMenuHUDobs::SortInc = 0;
		}

		callback.add(CallbackMsgVoteItem, "ZTMHUD.voteItemMessage");
		callback.add(CallbackMsgPlayerPopupItem, "ZTMHUD.playerPopupMessage");
		callback.add(CallbackMsgPlayerScore, "ZTMHUD.scoreInfo");
		callback.add(CallbackMsgClientJoin, "ZTMHUD.clJoin");
		callback.add(CallbackMsgClientJoinTeam, "ZTMHUD.clJoinTeam");
		callback.add(CallbackMsgClientDrop, "ZTMHUD.clDrop");

		ZTMHUD.init();

		parent::onWake(%this);
	}
};
activatePackage(ZTabMenuHUDoverloads);

if(!isObject(ZTMHUD))
{
	new ScriptObject(ZTMHUD)
	{
		class 	= ZTMHUD;
		version = "0.5";

		isA = false;
		isSA = false;
	};
}

function ZTabMenuHUDToggle(%val)
{
	if(%val)
	{
		if($ZTabMenuHUDOn)
		{
			canvas.popDialog(ZTabMenuHUD);
			canvas.setContent(playgui);
		}
		else
		{
			canvas.setContent(panoramagui);
			canvas.pushDialog(ZTabMenuHUD);
		}
	}
}

function ZTMHUD::voteFill(%this)
{
	ZTabMenuHUDvoteMenu.key++;
	ZTabMenuHUDvoteMenu.clear();
	ZTabMenuHUDvoteMenu.tourneyChoose = 0;
	commandToServer('GetVoteMenu', ZTabMenuHUDvoteMenu.key);
}

function ZTMHUD::voteFillTeam(%this)
{
	ZTabMenuHUDvoteMenu.key++;
	ZTabMenuHUDvoteMenu.clear();
	ZTabMenuHUDvoteMenu.mode = "team";
	commandToServer('GetTeamList', ZTabMenuHUDvoteMenu.key);
	ZTabMenuHUDvoteCancel.setVisible(true);
}

function ZTMHUD::voteFillMissionType(%this)
{
	ZTabMenuHUDvoteMenu.key++;
	ZTabMenuHUDvoteMenu.clear();
	ZTabMenuHUDvoteMenu.mode = "type";
	commandToServer('GetMissionTypes', ZTabMenuHUDvoteMenu.key);
	ZTabMenuHUDvoteCancel.setVisible(true);
}

function ZTMHUD::voteFillMission(%this, %type, %typeName)
{
	ZTabMenuHUDvoteMenu.key++;
	ZTabMenuHUDvoteMenu.clear();
	ZTabMenuHUDvoteMenu.mode = "mission";
	ZTabMenuHUDvoteMenu.missionType = %type;
	ZTabMenuHUDvoteMenu.typeName = %typeName;
	commandToServer('GetMissionList', ZTabMenuHUDvoteMenu.key, %type);
}

function ZTMHUD::voteFillTimeLimit(%this)
{
	ZTabMenuHUDvoteMenu.key++;
	ZTabMenuHUDvoteMenu.clear();
	ZTabMenuHUDvoteMenu.mode = "timeLimit";
	commandToServer('GetTimeLimitList', ZTabMenuHUDvoteMenu.key);
	ZTabMenuHUDvoteCancel.setVisible(true);
}

function ZTMHUD::voteItemMessage(%this, %msgType, %msgString, %key, %voteName, %voteActionMsg, %voteText, %sort)
{
	if (!$ZTabMenuHUDOn || %key != ZTabMenuHUDvoteMenu.key) return;
	
	%index = ZTabMenuHUDvoteMenu.rowCount();
	ZTabMenuHUDvoteMenu.addRow(%index, detag(%voteText));
	if (%sort) ZTabMenuHUDvoteMenu.sort(0);
	$clVoteCmd[%index] = detag(%voteName);
	$clVoteAction[%index] = detag(%voteActionMsg);
}

function ZTMHUD::voteControl(%this)
{
	%id = ZTabMenuHUDvoteMenu.getSelectedId();
	%text = ZTabMenuHUDvoteMenu.getRowTextById(%id);

	switch$ (ZTabMenuHUDvoteMenu.mode)
	{
		case "":
		switch$ ($clVoteCmd[%id])
		{
			case "JoinGame":
				CommandToServer('clientJoinGame');
				schedule(100, 0, ZTabMenuHUDToggle, true);
				return;
            
			case "ChooseTeam":
				ZTMHUD.voteFillTeam();
				return;

			case "VoteTournamentMode":
				ZTabMenuHUDvoteMenu.tourneyChoose = 1;
				ZTMHUD.voteFillMissionType();
				return; 
               
			case "VoteMatchStart":
				startNewVote("VoteMatchStart");
				schedule(100, 0, ZTabMenuHUDToggle, true);
				return;   

			case "MakeObserver":
				commandToServer('ClientMakeObserver');
				schedule(100, 0, ZTabMenuHUDToggle, true);
				return;

			case "VoteChangeMission":
				ZTMHUD.voteFillMissionType();
				return;

			case "VoteChangeTimeLimit":
				ZTMHUD.voteFillTimeLimit();
				return;
            
			case "Addbot":
				commandToServer('addBot');
				return;
		}

		case "team":
			commandToServer('ClientJoinTeam', %id++);
			schedule(100, 0, ZTabMenuHUDToggle, true);
			return;

		case "type":
			ZTMHUD.voteFillMission($clVoteCmd[%id], %text);
			return;

		case "mission":
			if(!ZTabMenuHUDvoteMenu.tourneyChoose)
			{
				startNewVote("VoteChangeMission", %text, ZTabMenuHUDvoteMenu.typeName, $clVoteCmd[%id], ZTabMenuHUDvoteMenu.missionType);
			}
			else
			{
				startNewVote("VoteTournamentMode", %text, ZTabMenuHUDvoteMenu.typeName, $clVoteCmd[%id], ZTabMenuHUDvoteMenu.missionType);
				ZTabMenuHUDvoteMenu.tourneyChoose = 0;
			}
			ZTabMenuHUDvoteMenu.reset();
			return;

		case "timeLimit":
			startNewVote("VoteChangeTimeLimit", $clVoteCmd[%id]);
			ZTabMenuHUDvoteMenu.reset();
			return;
	}

	startNewVote($clVoteCmd[%id], $clVoteAction[%id]);

	ZTMHUD.voteFill();
}

function ZTMHUD::init(%this)
{
	if(isObject(ZTabMenuHUD))
	{
		if(ZTabMenuHUD.playerDialogOpen) Canvas.popDialog(ZTabMenuHUDplayerActionDlg);
		canvas.popDialog(ZTabMenuHUD);
		ZTabMenuHUD.delete();
	}

	exec("gui/_ZTabMenuHUD.gui");

	ZTabMenuHUDobs.addColumn(0, " ", $pref::ZTabMenuHUDobs::Column0, 24, 24, "center");
	ZTabMenuHUDobs.addColumn(1, "Player", $pref::ZTabMenuHUDobs::Column1, 50, 500);
	ZTabMenuHUDobs.addColumn(2, "Score", $pref::ZTabMenuHUDobs::Column3, 25, 100, "numeric center");
	ZTabMenuHUDobs.addColumn(3, "Ping", $pref::ZTabMenuHUDobs::Column4, 20, 100, "numeric center");
	ZTabMenuHUDobs.addColumn(4, "PL", $pref::ZTabMenuHUDobs::Column5, 20, 100, "numeric center");
	ZTabMenuHUDobs.addColumn(5, "GUID", $pref::ZTabMenuHUDobs::Column6, 40, 100, "center");

	ZTabMenuHUDteam1.addColumn(0, " ", $pref::ZTabMenuHUDteam1::Column0, 24, 24, "center");
	ZTabMenuHUDteam1.addColumn(1, "Player", $pref::ZTabMenuHUDteam1::Column1, 50, 500);
	ZTabMenuHUDteam1.addColumn(2, "Score", $pref::ZTabMenuHUDteam1::Column3, 25, 100, "numeric center");
	ZTabMenuHUDteam1.addColumn(3, "Ping", $pref::ZTabMenuHUDteam1::Column4, 20, 100, "numeric center");
	ZTabMenuHUDteam1.addColumn(4, "PL", $pref::ZTabMenuHUDteam1::Column5, 20, 100, "numeric center");
	ZTabMenuHUDteam1.addColumn(5, "GUID", $pref::ZTabMenuHUDteam1::Column6, 40, 100, "center");

	ZTabMenuHUDteam2.addColumn(0, " ", $pref::ZTabMenuHUDteam2::Column0, 24, 24, "center");
	ZTabMenuHUDteam2.addColumn(1, "Player", $pref::ZTabMenuHUDteam2::Column1, 50, 500);
	ZTabMenuHUDteam2.addColumn(2, "Score", $pref::ZTabMenuHUDteam2::Column3, 25, 100, "numeric center");
	ZTabMenuHUDteam2.addColumn(3, "Ping", $pref::ZTabMenuHUDteam2::Column4, 20, 100, "numeric center");
	ZTabMenuHUDteam2.addColumn(4, "PL", $pref::ZTabMenuHUDteam2::Column5, 20, 100, "numeric center");
	ZTabMenuHUDteam2.addColumn(5, "GUID", $pref::ZTabMenuHUDteam2::Column6, 40, 100, "center");

	ZTMHUD.getScores();
}

function ZTMHUD::updatePlayer(%this, %clientId)
{
	%player = $PlayerList[%clientId];
	if(!isObject(%player)) return;
	if(%player.isSuperAdmin) %tag = "SA";
	else if(%player.isAdmin) %tag = "A";
	else if(%player.isBot) %tag = "B";
	else %tag = " ";

	%text = %tag TAB %player.name TAB %player.score TAB %player.ping TAB %player.packetLoss TAB %player.guid;

	switch(%player.teamId)
	{
		case 0: if(ZTabMenuHUDobs.getRowNumById(%clientId) == -1) ZTabMenuHUDobs.addRow(%clientId, %text);
			else ZTabMenuHUDobs.setRowById(%clientId, %text);

		case 1:	if(ZTabMenuHUDteam1.getRowNumById(%clientId) == -1) ZTabMenuHUDteam1.addRow(%clientId, %text);
			else ZTabMenuHUDteam1.setRowById(%clientId, %text);

		case 2: if(ZTabMenuHUDteam2.getRowNumById(%clientId) == -1) ZTabMenuHUDteam2.addRow(%clientId, %text);
			else ZTabMenuHUDteam2.setRowById(%clientId, %text);
	}

	if(teamtracker.teamGroup[0].getCount()>0)
	{
		%totalPing0 = 0;
		%totalScore0 = 0;

		for (%i=0; %i < teamtracker.teamGroup[0].getCount(); %i++)
		{
			%player = teamtracker.teamGroup[0].getObject(%i);
			%totalPing0 += %player.ping;
			%totalScore0 += %player.score;
		}

		%avgPing0 = getSubStr(%totalPing0/teamtracker.teamGroup[0].getCount(), 0, 5);
		%avgScore0 = getSubStr(%totalScore0/teamtracker.teamGroup[0].getCount(), 0, 5);

		ZTabMenuHUDobsName.setValue(teamtracker.teamName[0] @ "s");
		ZTabMenuHUDobsSize.position = (getWord(ZTabMenuHUDobsName.getPosition(), 0) + getWord(ZTabMenuHUDobsName.getExtent(), 0) + 10) @ " 675";
		ZTabMenuHUDobsSize.setValue("(" @ teamtracker.teamGroup[0].getCount() @ ")");
		ZTabMenuHUDobsavgPing.setValue("Avg. Ping: " @ %avgPing0);
		ZTabMenuHUDobsavgScore.setValue("Avg. Score: " @ %avgScore0);
	}

	if(teamtracker.teamGroup[1].getCount()>0)
	{
		%totalPing1 = 0;
		%totalScore1 = 0;

		for (%i=0; %i < teamtracker.teamGroup[1].getCount(); %i++)
		{
			%player = teamtracker.teamGroup[1].getObject(%i);
			%totalPing1 += %player.ping;
			%totalScore1 += %player.score;
		}

		%avgPing1 = getSubStr(%totalPing1/teamtracker.teamGroup[1].getCount(), 0, 5);
		%avgScore1 = getSubStr(%totalScore1/teamtracker.teamGroup[1].getCount(), 0, 5);

		ZTabMenuHUDteam1Name.setValue(teamtracker.teamName[1]);
		ZTabMenuHUDteam1Size.position = (getWord(ZTabMenuHUDteam1Name.getPosition(), 0) + getWord(ZTabMenuHUDteam1Name.getExtent(), 0) + 10) @ " 75";
		ZTabMenuHUDteam1Size.setValue("(" @ teamtracker.teamGroup[1].getCount() @ ")");
		ZTabMenuHUDteam1avgPing.setValue("Avg. Ping: " @ %avgPing1);
		ZTabMenuHUDteam1avgScore.setValue("Avg. Score: " @ %avgScore1);
	}

	if(teamtracker.teamGroup[2].getCount()>0)
	{
		%totalPing2 = 0;
		%totalScore2 = 0;

		for (%i=0; %i < teamtracker.teamGroup[2].getCount(); %i++)
		{
			%player = teamtracker.teamGroup[2].getObject(%i);
			%totalPing2 += %player.ping;
			%totalScore2 += %player.score;
		}

		%avgPing2 = getSubStr(%totalPing2/teamtracker.teamGroup[2].getCount(), 0, 5);
		%avgScore2 = getSubStr(%totalScore2/teamtracker.teamGroup[2].getCount(), 0, 5);

		ZTabMenuHUDteam2Name.setValue(teamtracker.teamName[2]);
		ZTabMenuHUDteam2Size.position = (getWord(ZTabMenuHUDteam2Name.getPosition(), 0) + getWord(ZTabMenuHUDteam2Name.getExtent(), 0) + 10) @ " 375";
		ZTabMenuHUDteam2Size.setValue("(" @ teamtracker.teamGroup[2].getCount() @ ")");
		ZTabMenuHUDteam2avgPing.setValue("Avg. Ping: " @ %avgPing2);
		ZTabMenuHUDteam2avgScore.setValue("Avg. Score: " @ %avgScore2);
	}

	ZTabMenuHUDobs.sort();
	ZTabMenuHUDteam1.sort();
	ZTabMenuHUDteam2.sort();
}

function ZTMHUD::removePlayer(%this, %clientId)
{
	%player = $PlayerList[%clientId];

	if(%player.teamId == 0) ZTabMenuHUDobs.removeRowById(%player.clientId);
	if(%player.teamId == 1) ZTabMenuHUDteam1.removeRowById(%player.clientId);
	if(%player.teamId == 2) ZTabMenuHUDteam2.removeRowById(%player.clientId);
}

function ZTMHUD::clJoin(%this, %msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
	if (strstr(%msgString, "Welcome to Tribes2") != -1)
	{
		if(%isAdmin) %this.isA = true;
		else %this.isA = false;

		if(%isSuperAdmin) %this.isSA = true;
		else %this.isSA = false;
	}

	ZTMHUD.updatePlayer(%clientId);
}

function ZTMHUD::clJoinTeam(%this, %msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
	ZTMHUD.removePlayer(%clientId);
//	ZTMHUD.updatePlayer(%clientId);
}

function ZTMHUD::clDrop(%this, %msgType, %msgString, %clientName, %clientId)
{
	ZTMHUD.removePlayer(%clientId);
}

function ZTMHUD::scoreInfo(%this, %msgType, %msgString, %clientId, %score, %ping, %packetLoss)
{
	ZTMHUD.updatePlayer(%clientId);
}

function ZTMHUD::getScores(%this)
{
	if($scoreLoop) cancel($scoreLoop);
	commandToServer('getScores');
	$scoreLoop = ZTMHUD.schedule(1000, getScores);
}

function ZTabMenuHUDplayerActionDlg::onWake(%this)
{
	ZTabMenuHUD.playerDialogOpen = true;
	ZTMHUD.playerPopupMenu();
}

function ZTabMenuHUDplayerActionDlg::onSleep(%this)
{
	ZTabMenuHUD.playerDialogOpen = false;
}

function ZTabMenuHUDplayerPopup::onSelect(%this, %id, %text)
{
	//1	text mute
	//2	vote admin
	//3	vote kick
	//4	sa ban
	//5	a force observer
	//6	a switch team
	//7	a switch team
	//8	force join
	//9	disable voice com
	//10	sa add to admin
	//11	sa add to sa
	//12	observe player
	//13	a warn
	//14	a strip admin
	//15	a pm
	//16	a client info
	//17	sa gag player
	//18	sa freeze player
	//19	sa boot player
	//20	sa explode player

	// ATFADMIN POPUP MENU CODES:

	// 601 warn player (admin only)
	// 602 observe player
	// 603 global mute
	// 604 global unmute
	// 605 lightning strike (admin only)
	// 606 add to privileged list (admin only)
	// 607 remove from privileged list (admin only)
	// 608 blow up player (admin only)
	// 609 allow single-player voting (admin only)
	// 610 disallow single-player voting (admin only)
	// 611 voice pack temporary block (admin only)
	// 612 voice pack permanent block (admin only)
	// 613 voice pack unblock (admin only)

	switch(%id)
	{
		case 1:		togglePlayerMute(%this.player.clientId);
		
		case 2:		MessageBoxYesNo("CONFIRM", "Are you sure you want to make " @ %this.player.name @ " an admin?", "ZTMHUD.playerVote(VoteAdminPlayer, " @ %this.player.clientId @ ");");
	
		case 3:		MessageBoxYesNo("CONFIRM", "Are you sure you want to kick " @ %this.player.name @ "?", "ZTMHUD.playerVote(VoteKickPlayer, " @ %this.player.clientId @ ");");
		
		case 4:		MessageBoxYesNo("CONFIRM", "Are you sure you want to ban " @ %this.player.name @ "?", "ZTMHUD.playerVote(BanPlayer, " @ %this.player.clientId @ ");");
		
		case 5:		forceToObserver(%this.player.clientId);   
		
		case 6:		changePlayersTeam(%this.player.clientId, 1);
				ZTMHUD.voteFill();
		
		case 7:		changePlayersTeam(%this.player.clientId, 2);
				ZTMHUD.voteFill();
		
		case 8:		adminAddPlayerToGame(%this.player.clientId);
		
		case 9:		togglePlayerVoiceCom(%this.player);
	
		case 10:	confirmAdminListAdd(%this.player, false);
		
		case 11:	confirmAdminListAdd(%this.player, true);
			
		case 12:	commandToServer('processGameLink', %this.player.clientId);

		case 13:	commandToServer('warnPlayer', %this.player);

		case 14:	commandToServer('stripAdmin', %this.player);

		case 15:	commandToServer('privateMessageSent', %this.player, %text);

		case 16:	commandToServer('printClientInfo', %this.player);

		case 17:	commandToServer('togglePlayerGag', %this.player.clientId);
				if(%this.player.gagged) %this.player.gagged = !%this.player.gagged;
				else %this.player.gagged = true;

		case 18:	commandToServer('togglePlayerFreeze', %this.player.clientId);
				if(%this.player.frozen) %this.player.frozen = !%this.player.frozen;
				else %this.player.frozen = true;

		case 19:	commandToServer('bootToTheRear', %this.player.clientId);

		case 20:	commandToServer('explodePlayer', %this.player.clientId);

		case 900:	LinkEMail(baseName(%this.player));

		case 901:	LinkAddBuddy(baseName(%this.player), TWBText, "addBuddy");
	}

	canvas.popDialog(ZTabMenuHUDplayerActionDlg);
}

function ZTabMenuHUDplayerPopup::onCancel(%this)
{
	canvas.popDialog(ZTabMenuHUDplayerActionDlg);
}

function ZTMHUD::playerPopupMenu(%this)
{
	ZTabMenuHUDplayerPopup.key++;
	ZTabMenuHUDplayerPopup.clear();

	ZTabMenuHUDplayerPopup.add(ZTabMenuHUDplayerPopup.player.name, 0);

	ZTabMenuHUDplayerPopup.add("--------------------", 0);

	%line = detag("Warn player");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 13);

	%line = detag("Gag player");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 17);

	%line = detag("Freeze player");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 18);

	%line = detag("Smack player");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 19);

	%line = detag("Explode player");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 20);

	%line = detag("Player info");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 16);

	ZTabMenuHUDplayerPopup.add("--------------------", 0);

	%line = detag("Private Message");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 15);

	%line = detag("Tmail");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 900);

	%line = detag("Add to buddies");
	ZTabMenuHUDplayerPopup.add("	" @ %line, 901);

	commandToServer('GetPlayerPopupMenu', ZTabMenuHUDplayerPopup.player.clientId, ZTabMenuHUDplayerPopup.key);
}

function ZTMHUD::playerPopupMessage(%this, %msgType, %msgString, %key, %voteName, %voteActionMsg, %voteText, %popupEntryId)
{
	if(!$ZTabMenuHUDOn || %key != ZTabMenuHUDplayerPopup.key) return;
	ZTabMenuHUDplayerPopup.add("	" @ detag(%voteText), %popupEntryId);
}

function ZTMHUD::playerVote(%this, %voteType, %playerId)
{
	startNewVote(%voteType, %playerId, 0, 0, 0, true);
	ZTMHUD.voteFill();
}

function ZTabMenuHUD::onWake(%this)
{
	$ZTabMenuHUDOn = true;

	if(!%this.init)
	{
		ZTabMenuHUDobs.setSortColumn($pref::ZTabMenuHUDobs::SortColumnKey);
		ZTabMenuHUDobs.setSortIncreasing($pref::ZTabMenuHUDobs::SortInc);
		ZTabMenuHUDteam1.setSortColumn($pref::ZTabMenuHUDteam1::SortColumnKey);
		ZTabMenuHUDteam1.setSortIncreasing($pref::ZTabMenuHUDteam1::SortInc);
		ZTabMenuHUDteam2.setSortColumn($pref::ZTabMenuHUDteam2::SortColumnKey);
		ZTabMenuHUDteam2.setSortIncreasing($pref::ZTabMenuHUDteam2::SortInc);

		%this.init = true;
	}

	ZTMHUD.voteFill();

	ZTabMenuHUDServerName.setValue(missioncallback.getServerName());
	ZTabMenuHUDServerModNType.setValue(strUpr(missioncallback.getservermod()) @ " " @ missioncallback.getmissiontype());
	ZTabMenuHUDMap.setValue(missioncallback.getmissionname());
	ZTabMenuHUDIP.setValue(missioncallback.getserveraddress());
	ZTabMenuHUDIP.position = (getWord(ZTabMenuHUDServerName.getExtent(), 0) + 15) @ " 12";

	GlobalActionMap.copyBind(moveMap, ZTabMenuHUDToggle);
}

function ZTabMenuHUD::onSleep(%this)
{
	$ZTabMenuHUDOn = false;

	clearMapping(GlobalActionMap, ZTabMenuHUDToggle);
}

function ZTabMenuHUD::onAdd(%this)
{
	new GuiControl(ZTabMenuHUDPlayerActionDlg)
	{
		profile = "GuiModelessDialogProfile";
		horizSizing = "width";
		vertSizing = "height";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		setFirstResponder = "0";
		modal = "1";

		new ShellPopupMenu(ZTabMenuHUDPlayerPopup)
		{
			profile = "ShellPopupProfile";
			position = "0 0";
			extent = "0 0";
			minExtent = "0 0";
			visible = "1";
			maxPopupHeight = "200";
			noButtonStyle = "1";
		};
	};
}

function ZTabMenuHUDvoteMenu::reset(%this)
{
	%this.mode = "";
	%this.tourneyChoose = 0;
	ZTabMenuHUDvoteCancel.setVisible(false);
	ZTMHUD.voteFill();
}

function ZTabMenuHUDteam1::onColumnResize(%this, %col, %size)
{
	$pref::ZTabMenuHUDteam1::Column[%this.getColumnKey(%col)] = %size;
}

function ZTabMenuHUDteam1::onSetSortKey(%this, %key, %increasing)
{
	$pref::ZTabMenuHUDteam1::SortColumnKey = %key;
	$pref::ZTabMenuHUDteam1::SortInc = %increasing;
}

function ZTabMenuHUDteam1::SaveColumns(%this)
{
	%count = %this.getNumColumns();
	for (%col = 0; %col < %count; %col++)
	{
		$pref::ZTabMenuHUDteam1::Column[%this.getColumnKey(%col)] = %this.getColumnWidth(%col);
	}
}

function ZTabMenuHUDteam1::onRightMouseDown(%this, %column, %row, %mousePos)
{
	%clientId = %this.getRowId(%row);
	ZTabMenuHUDplayerPopup.player = $PlayerList[%clientId];

	if(ZTabMenuHUDplayerPopup.player !$= "")
	{
		ZTabMenuHUDplayerPopup.position = %mousePos;
		canvas.pushDialog(ZTabMenuHUDplayerActionDlg);
		ZTabMenuHUDplayerPopup.forceOnAction();
	}
}

function ZTabMenuHUDteam2::onColumnResize(%this, %col, %size)
{
	$pref::ZTabMenuHUDteam2::Column[%this.getColumnKey(%col)] = %size;
}

function ZTabMenuHUDteam2::onSetSortKey(%this, %key, %increasing)
{
	$pref::ZTabMenuHUDteam2::SortColumnKey = %key;
	$pref::ZTabMenuHUDteam2::SortInc = %increasing;
}

function ZTabMenuHUDteam2::SaveColumns(%this)
{
	%count = %this.getNumColumns();
	for (%col = 0; %col < %count; %col++)
	{
		$pref::ZTabMenuHUDteam2::Column[%this.getColumnKey(%col)] = %this.getColumnWidth(%col);
	}
}

function ZTabMenuHUDteam2::onRightMouseDown(%this, %column, %row, %mousePos)
{
	%clientId = %this.getRowId(%row);
	ZTabMenuHUDplayerPopup.player = $PlayerList[%clientId];

	if(ZTabMenuHUDplayerPopup.player !$= "")
	{
		ZTabMenuHUDplayerPopup.position = %mousePos;
		canvas.pushDialog(ZTabMenuHUDplayerActionDlg);
		ZTabMenuHUDplayerPopup.forceOnAction();
	}
}

function ZTabMenuHUDobs::onColumnResize(%this, %col, %size)
{
	$pref::ZTabMenuHUDobs::Column[%this.getColumnKey(%col)] = %size;
}

function ZTabMenuHUDobs::onSetSortKey(%this, %key, %increasing)
{
	$pref::ZTabMenuHUDobs::SortColumnKey = %key;
	$pref::ZTabMenuHUDobs::SortInc = %increasing;
}

function ZTabMenuHUDobs::SaveColumns(%this)
{
	%count = %this.getNumColumns();
	for (%col = 0; %col < %count; %col++)
	{
		$pref::ZTabMenuHUDobs::Column[%this.getColumnKey(%col)] = %this.getColumnWidth(%col);
	}
}

function ZTabMenuHUDobs::onRightMouseDown(%this, %column, %row, %mousePos)
{
	%clientId = %this.getRowId(%row);
	ZTabMenuHUDplayerPopup.player = $PlayerList[%clientId];

	if(ZTabMenuHUDplayerPopup.player !$= "")
	{
		ZTabMenuHUDplayerPopup.position = %mousePos;
		canvas.pushDialog(ZTabMenuHUDplayerActionDlg);
		ZTabMenuHUDplayerPopup.forceOnAction();
	}
}